
def solve(words):
    # for each pair of words (including a word with itself) try all ways to overlap them
    for u in words:
        for v in words:
            for i in range(5):
                if v.startswith(u[i:]):
                    s = u[:i] + v
                    # and now try appending all other words that are not in s yet
                    for w in words:
                        if w not in s:
                            s += w
                    # did we find a solution?
                    if len(s) <= 39:
                        # do not forget padding if it is too short
                        return s + 'A' * (39 - len(s))

t = int(input())
for i in range(t):
    input()
    print(solve(input().split()))

